> ## Documentation Index
> Fetch the complete documentation index at: https://docs.topsort.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Upsert Vendors

> Upsert vendors.



## OpenAPI

````yaml /openapi.json put /public/v1/catalog-search-service/catalogs/vendors
openapi: 3.1.0
info:
  title: Topsort Endpoints v2 API Reference
  description: >
    In order for a storefront to be able to run auctions in Topsort and report
    auction-related events back to Topsort,

    both the `/v2/auctions` and `/v2/events` endpoints must be integrated.

    Below are the endpoint and model definitions for each.
  contact:
    email: wicha@topsort.com
  license:
    name: Apache 2.0
    url: http://www.apache.org/licenses/LICENSE-2.0.html
  x-logo:
    url: https://assets.topsort.com/Topsort_logo_icon_dark.svg
    backgroundColor: '#fff'
    altText: Topsort
  version: 2.0.0
servers:
  - url: https://api.topsort.com
    description: Base API URL
security: []
tags:
  - name: Auctions
    description: >-
      An auction determines which products should be promoted based on the
      vendors' bids.
  - name: Events
    description: >-
      Events are sent to Topsort as part of the attribution and reporting
      journey.
  - name: Toptimize
    description: >
      An out-of-the-box solution for prediction, ranking, retrieval, and other
      elements of ad selection.
  - name: Toppie API
    description: Toppie management API.
  - name: Campaign API
    description: Full-featured campaign management API for banners and sponsored listings.
  - name: Catalog API
    description: Products catalog management API.
  - name: Billing API
    description: Marketplace and Vendor Billing management API.
  - name: Reporting API
    description: Marketplace, Vendor, Campaign, and product reporting API.
  - name: Invitation API
    description: Vendor invitations management API.
  - name: User API
    description: User management API.
  - name: Webhooks API
    description: Webhooks API that allows event-driven automation.
  - name: Assets API
    description: Assets management API.
  - name: Segments Service
    description: Segments Service.
  - name: Forecasting Service
    description: Toptimize Forecasting Service.
  - name: Offsite Ads API
    description: Offsite Ads API that allows to manage offsite ads campaigns.
  - name: Media API
    description: Ad configuration API.
paths:
  /public/v1/catalog-search-service/catalogs/vendors:
    put:
      tags:
        - Catalog API
      summary: Upsert Vendors
      description: Upsert vendors.
      operationId: upsert_vendors
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/Advanced_APIs_VendorsRequest'
      responses:
        '204':
          description: Successful Response
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Advanced_APIs_HTTPValidationError'
      security:
        - Advanced_APIs_HTTPBearer: []
components:
  schemas:
    Advanced_APIs_VendorsRequest:
      properties:
        vendors:
          items:
            $ref: '#/components/schemas/Advanced_APIs_CatalogVendor'
          type: array
          maxItems: 500
          minItems: 1
          title: Vendors
          description: Create or replace one or more vendors in the catalog.
      type: object
      required:
        - vendors
      title: VendorsRequest
    Advanced_APIs_HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/Advanced_APIs_ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    Advanced_APIs_CatalogVendor:
      properties:
        id:
          type: string
          maxLength: 255
          minLength: 1
          title: Id
          description: >-
            Unique ID of the vendor. Topsort treats IDs as strings, choose any
            format as long as it is unique within the catalog.
          examples:
            - 9SiwYqqL8vdG
            - VENDOR-456
            - 5c30432c-1186-4389-a2f1-577bb8dd5180
        name:
          type: string
          minLength: 1
          title: Name
          description: >-
            Name of the Vendor. Shown in Topsort UI. Truncated to 150
            characters.
          examples:
            - Huyghe Brewery
            - Sneakers Inc.
            - Electronics International
        imageURL:
          format: uri
          title: Imageurl
          description: >-
            URL of the vendor image. This image will be displayed in the Topsort
            UI along with the name of the vendor.  Image dimensions between
            250x250 and 600x600 pixels are recommended for the best performance
            of the Topsort UI.
          examples:
            - https://cdn.example.com/logos/9SiwYqqL8vdG.jpg
          oneOf:
            - type: string
              minLength: 1
            - type: 'null'
        vendor_role:
          description: >-
            Role of the vendor in the Topsort UI. Defaults to admin. Vendors
            with the admin role  have full control to manage and set up their
            own campaigns. Vendors with the analytics role have read-only 
            access to campaigns and reporting but require the marketplace admin
            to manage their campaigns.
          oneOf:
            - $ref: '#/components/schemas/Advanced_APIs_UserServiceVendorRole'
            - type: 'null'
        merchant_center_id:
          title: Merchant Center Id
          description: The Google Merchant Center ID.
          examples:
            - 1456723
          oneOf:
            - type: integer
            - type: 'null'
        globalId:
          title: Globalid
          description: Global identifier for grouping vendors across marketplaces.
          examples:
            - vendor_group_123
            - global_brand_abc
            - multi_marketplace_xyz
          oneOf:
            - type: string
              maxLength: 255
              minLength: 1
            - type: 'null'
      type: object
      required:
        - id
        - name
      title: CatalogVendor
      description: A vendor is a brand or other entity that promotes products in campaigns.
    Advanced_APIs_ValidationError:
      properties:
        loc:
          items:
            oneOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    Advanced_APIs_UserServiceVendorRole:
      type: string
      enum:
        - admin
        - analytics
      title: UserServiceVendorRole
  securitySchemes:
    Advanced_APIs_HTTPBearer:
      type: http
      description: >-
        A valid API key generated in Topsort's UI. Use the TSE API key if
        calling auctions or events API, otherwise use the TSC API key.
      scheme: bearer

````